VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FL_CDInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'*******************************************
'*** Flamed CD-R(W/OM) information
'***
'*** reads information about a CD-R/ROM/RW
'*******************************************

Private udeMediaType    As e_CDType
Private udeCDRWType     As e_CD_SubType

Private udeMediaStatus  As e_Status
Private udeLastSessionState As e_Status

Private lngLeadInLBA    As New FL_MSF
Private lngLeadOutLBA   As New FL_MSF

Private intSessions     As Integer
Private intTracks       As Integer

Public Property Get Sessions() As Integer
    Sessions = intSessions
End Property

Public Function GetInfo(ByVal driveid As String) As Boolean

    ' drive is ready?
    If Not CDRomTestUnitReady(driveid) Then Exit Function
    GetInfo = True

    With CDRomGetCDInfo(driveid)

        udeCDRWType = .CDSubType
        udeMediaType = .CDType
        udeMediaStatus = .DiscStatus
        udeLastSessionState = .LastSessionStatus

        lngLeadInLBA.LBA = .LeadIn.LBA
        lngLeadOutLBA.LBA = .LeadOut.LBA

        intSessions = .Sessions
        intTracks = .Tracks

    End With

End Function
