VERSION 5.00
Begin VB.Form frmViewMR 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "View MR logo"
   ClientHeight    =   3300
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   5295
   Icon            =   "frmViewMR.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3300
   ScaleWidth      =   5295
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      Height          =   3135
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   5055
      Begin VB.PictureBox Picture1 
         AutoRedraw      =   -1  'True
         AutoSize        =   -1  'True
         BorderStyle     =   0  'None
         FillStyle       =   0  'Solid
         Height          =   1335
         Left            =   110
         ScaleHeight     =   89
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   320
         TabIndex        =   1
         Top             =   240
         Width           =   4800
      End
      Begin VB.Label lblColors 
         AutoSize        =   -1  'True
         Height          =   195
         Left            =   1080
         TabIndex        =   9
         Top             =   2760
         Width           =   45
      End
      Begin VB.Label lblResolution 
         AutoSize        =   -1  'True
         Height          =   195
         Left            =   1080
         TabIndex        =   8
         Top             =   2520
         Width           =   45
      End
      Begin VB.Label lblOffset 
         AutoSize        =   -1  'True
         Height          =   195
         Left            =   1080
         TabIndex        =   7
         Top             =   2280
         Width           =   45
      End
      Begin VB.Label lblSize 
         AutoSize        =   -1  'True
         Height          =   195
         Left            =   1080
         TabIndex        =   6
         Top             =   1800
         Width           =   45
      End
      Begin VB.Label Label6 
         AutoSize        =   -1  'True
         Caption         =   "Colors:"
         Height          =   195
         Left            =   120
         TabIndex        =   5
         Top             =   2760
         Width           =   480
      End
      Begin VB.Label Label5 
         AutoSize        =   -1  'True
         Caption         =   "Resolution:"
         Height          =   195
         Left            =   120
         TabIndex        =   4
         Top             =   2520
         Width           =   795
      End
      Begin VB.Label Label3 
         AutoSize        =   -1  'True
         Caption         =   "Offset:"
         Height          =   195
         Left            =   120
         TabIndex        =   3
         Top             =   2280
         Width           =   465
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         Caption         =   "Size:"
         Height          =   195
         Left            =   120
         TabIndex        =   2
         Top             =   1800
         Width           =   345
      End
   End
   Begin VB.Menu mnuExport 
      Caption         =   "&Export"
      Begin VB.Menu mnuExportToBMP 
         Caption         =   "To &BMP..."
      End
      Begin VB.Menu mnuExportToGIF 
         Caption         =   "To &GIF..."
      End
      Begin VB.Menu mnuExportToJPG 
         Caption         =   "To &JPG..."
      End
      Begin VB.Menu mnuExportToPNG 
         Caption         =   "To &PNG..."
      End
      Begin VB.Menu mnuExportToTIFF 
         Caption         =   "To &TIFF..."
      End
   End
End
Attribute VB_Name = "frmViewMR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents gdip As cGdiPlus
Attribute gdip.VB_VarHelpID = -1

Private Sub Form_Load()
    Set gdip = New cGdiPlus
End Sub

Private Sub mnuExportToBMP_Click()

    Dim strCdlgFilter   As String
    Dim sFile           As String

    strCdlgFilter = "Bitmap (*.bmp)|*.bmp|" & _
                    "All files (*.*)|*.*"
    sFile = ShowSave(strCdlgFilter, "iplogo.bmp", "bmp", OVERWRITEPROMPT, frmViewMR)
    If sFile = "" Then Exit Sub
        
    Call SavePicture(Picture1.Image, sFile)
    
    MsgBox "Successfully exported the MR logo to BMP!", vbInformation, "Information"

End Sub

Private Sub mnuExportToGIF_Click()

    Dim strCdlgFilter   As String
    Dim sFile           As String

    strCdlgFilter = "GIF (*.gif)|*.gif|" & _
                    "All files (*.*)|*.*"
    sFile = ShowSave(strCdlgFilter, "iplogo.gif", "gif", OVERWRITEPROMPT, frmViewMR)
    If sFile = "" Then Exit Sub

    gdip.PictureBoxToFile Picture1, sFile
    
    MsgBox "Successfully exported the MR logo to GIF!", vbInformation, "Information"

End Sub

Private Sub mnuExportToJPG_Click()

    Dim strCdlgFilter   As String
    Dim sFile           As String

    strCdlgFilter = "JPEG (*.jpg)|*.jpg|" & _
                    "All files (*.*)|*.*"
    sFile = ShowSave(strCdlgFilter, "iplogo.jpg", "jpg", OVERWRITEPROMPT, frmViewMR)
    If sFile = "" Then Exit Sub

    gdip.PictureBoxToFile Picture1, sFile
    
    MsgBox "Successfully exported the MR logo to JPEG!", vbInformation, "Information"

End Sub

Private Sub mnuExportToPNG_Click()

    Dim strCdlgFilter   As String
    Dim sFile           As String
    
    strCdlgFilter = "PNG (*.png)|*.png|" & _
                    "All files (*.*)|*.*"
    sFile = ShowSave(strCdlgFilter, "iplogo.png", "png", OVERWRITEPROMPT, frmViewMR)
    If sFile = "" Then Exit Sub

    gdip.PictureBoxToFile Picture1, sFile
    
    MsgBox "Successfully exported the MR logo to PNG!", vbInformation, "Information"
  
End Sub

Private Sub mnuExportToTIFF_Click()

    Dim strCdlgFilter   As String
    Dim sFile           As String

    strCdlgFilter = "TIFF (*.tiff; *.tif)|*.tiff; *.tif|" & _
                    "All files (*.*)|*.*"
    sFile = ShowSave(strCdlgFilter, "iplogo.tiff", "tiff", OVERWRITEPROMPT, frmViewMR)
    If sFile = "" Then Exit Sub

    gdip.PictureBoxToFile Picture1, sFile
    
    MsgBox "Successfully exported the MR logo to TIFF!", vbInformation, "Information"

End Sub
