Attribute VB_Name = "modMR"
Option Explicit
    
'Add MR logo
Public Sub AddMRLogo(sFile As String, src As enm_Source)
 
On Error GoTo ErrorHandler
 
    Dim strMRData       As String
    Dim lngBytesRemainMR As Long
    Dim lngByteStartsMR As Long
    Dim i As Integer, j As Integer
    
    If FileLen(sFile) > 8192 Then
        If MsgBox("This MR will not fit in a normal IP.BIN. It's " & FileLen(sFile) - 8192 & " bytes too big." & vbCrLf & "Do you want to continue?", vbExclamation + vbYesNo, "Warning") = vbNo Then
            Exit Sub
        End If
    End If
    
    Select Case src
        
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            
            Select Case MsgBoxA("Do you want to add the MR logo to the current IP.BIN or the entire CD image?", "Question", "", MB_ICONQUESTION + MB_YESNOCANCEL, , "Cancel", "Current", "All")
                
                '// CURRENT
                Case vbYes
                    Open frmMain.txtFilename.Text For Binary As #1
                        ReDim btMR(3) As Byte
                        Get #1, bytePosition + (((2048 + lngBytesOfECC) * 7) + 32), btMR()
                        strMRData = StrConv(btMR(), vbUnicode)
                    Close #1
                        
                    'remove any old MR
                    If Mid$(strMRData, 1, 2) = "MR" Then
                        lngBytesRemainMR = CLng("&H" & Hex$(Asc(Mid$(strMRData, 4, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 3, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 3, 1))))
                        
                        'remove the MR
                        Open frmMain.txtFilename.Text For Binary As #1
                            'remove first sector data
                            Put #1, bytePosition + (((2048 + lngBytesOfECC) * 7) + 32), String$(2016, Chr$(0))
                            
                            lngBytesRemainMR = lngBytesRemainMR - 2016
                            
                            'loop until MR is completely removed
                            Do Until lngBytesRemainMR <= 0
                                Seek #1, Loc(1) + lngBytesOfECC + 1 'skip ECC
                                If lngBytesRemainMR >= 2048 Then
                                    Put #1, , String$(2048, Chr$(0)) 'remove data in sector
                                    lngBytesRemainMR = lngBytesRemainMR - 2048 'remaining bytes to remove
                                Else
                                    Put #1, , String$(lngBytesRemainMR, Chr$(0)) 'remove remaing MR
                                    lngBytesRemainMR = lngBytesRemainMR - lngBytesRemainMR
                                End If
                            Loop
                        Close #1
                    End If
                    
                    lngBytesRemainMR = FileLen(sFile)
                    lngByteStartsMR = 1
                    
                    'add MR to current IP.BIN in the CD image
                    Open sFile For Binary As #1
                        Open frmMain.txtFilename.Text For Binary As #2
                    
                            ReDim btMR(2016 - 1) As Byte 'MR buffer
                            Get #1, lngByteStartsMR, btMR() 'put MR in the buff
                            Put #2, bytePosition + (((2048 + lngBytesOfECC) * 7) + 32), btMR() 'put buff in current IP.BIN
                            
                            lngBytesRemainMR = lngBytesRemainMR - 2016
                            lngByteStartsMR = lngByteStartsMR + 2016
                            
                            'insert the remaining bytes into the current IP.BIN
                            Do Until lngBytesRemainMR <= 0
                                Seek #2, Loc(2) + lngBytesOfECC + 1 'skip ECC
                        
                                If lngBytesRemainMR >= 2048 Then
                                    ReDim btMR(2048 - 1) As Byte 'sector size buffer
                                    Get #1, lngByteStartsMR, btMR()
                                    lngByteStartsMR = lngByteStartsMR + 2048
                                    lngBytesRemainMR = lngBytesRemainMR - 2048
                                Else 'less then 2048 bytes left of MR
                                    ReDim btMR(lngBytesRemainMR - 1) As Byte 'remaining bytes buffer
                                    Get #1, lngByteStartsMR, btMR() 'put remaing bytes of MR in the buffer
                                    lngBytesRemainMR = lngBytesRemainMR - lngBytesRemainMR
                                End If
                                
                                Put #2, , btMR()
                            Loop
                            
                        Close #2
                        
                    Close #1
                
                '// ALL
                Case vbNo
                    'remove any current MRs
                    For i = LBound(IPS_AT_BYTE, 2) To UBound(IPS_AT_BYTE, 2)
                        If IPS_AT_BYTE(0, i) = "IP.BIN" Then
                        
                            Open sFile For Binary As #1
                                ReDim btMR(3) As Byte
                                Get #1, IPS_AT_BYTE(1, i) + (((2048 + lngBytesOfECC) * 7) + 32), btMR()
                                strMRData = StrConv(btMR(), vbUnicode)
                            Close #1
                            
                            If Mid$(strMRData, 1, 2) = "MR" Then
                                lngBytesRemainMR = CLng("&H" & Hex$(Asc(Mid$(strMRData, 4, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 3, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 3, 1))))
                                
                                Open sFile For Binary As #1
                                    Put #1, IPS_AT_BYTE(1, i) + (((2048 + lngBytesOfECC) * 7) + 32), String$(2016, Chr$(0))
                                
                                    lngBytesRemainMR = lngBytesRemainMR - 2016
                                    
                                    'loop until all of MR is removed
                                    Do Until lngBytesRemainMR = 0
                                        Seek #1, Loc(1) + lngBytesOfECC + 1 'seek over ECC
                                        
                                        If lngBytesRemainMR >= 2048 Then
                                            Put #1, , String$(2048, Chr$(0)) 'remove current sector
                                            lngBytesRemainMR = lngBytesRemainMR - 2048
                                        Else
                                            Put #1, , String$(lngBytesRemainMR, Chr$(0)) 'remove remaining bytes
                                            lngBytesRemainMR = lngBytesRemainMR - lngBytesRemainMR
                                        End If
                                    Loop
                                Close #1
                            End If
                            
                        End If
                    Next
                
                    'add the MR to all IP.BINs
                    For i = LBound(IPS_AT_BYTE, 2) To UBound(IPS_AT_BYTE, 2)
                        If IPS_AT_BYTE(0, i) = "IP.BIN" Then
                    
                            lngBytesRemainMR = FileLen(sFile)
                            lngByteStartsMR = 1
                        
                            Open sFile For Binary As #1
                                Open frmMain.txtFilename.Text For Binary As #2
                            
                                    'put the first 2016 MR bytes in the CD image
                                    ReDim btMR(2016 - 1) As Byte
                                    Get #1, lngByteStartsMR, btMR()
                                    Put #2, IPS_AT_BYTE(1, i) + (((2048 + lngBytesOfECC) * 7) + 32), btMR()
                                    
                                    lngBytesRemainMR = lngBytesRemainMR - 2016
                                    lngByteStartsMR = lngByteStartsMR + 2016
                            
                                    'insert the remaining bytes into the current IP.BIN
                                    Do Until lngBytesRemainMR <= 0
                                        Seek #2, Loc(2) + lngBytesOfECC + 1 'skip ECC
                                
                                        If lngBytesRemainMR >= 2048 Then
                                            ReDim btMR(2048 - 1) As Byte 'sector size buffer
                                            Get #1, lngByteStartsMR, btMR()
                                            lngByteStartsMR = lngByteStartsMR + 2048
                                            lngBytesRemainMR = lngBytesRemainMR - 2048
                                        Else 'less then 2048 bytes left of MR
                                            ReDim btMR(lngBytesRemainMR - 1) As Byte 'remaining bytes buffer
                                            Get #1, lngByteStartsMR, btMR() 'put remaing bytes of MR in the buffer
                                            lngBytesRemainMR = lngBytesRemainMR - lngBytesRemainMR
                                        End If
                                        
                                        Put #2, , btMR()
                                    Loop
                                    
                                Close #2
                            Close #1
                            
                        End If
                    Next
                
                '// cancel
                Case vbCancel
                    Exit Sub
                
            End Select
        
        '//
        '// IP.BIN
        '//
        Case SOURCE_IP
            Open frmMain.txtFilename.Text For Binary As #1
                ReDim btMR(3) As Byte 'create buffer
                Get #1, 14369, btMR() 'put MR ID + filesize in buffer
                strMRData = StrConv(btMR(), vbUnicode) 'convert to a readable format
                
                'remove any current logo
                If Mid$(strMRData, 1, 2) = "MR" Then
                    lngBytesRemainMR = CLng("&H" & Hex$(Asc(Mid$(strMRData, 4, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 3, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 3, 1))))
                    Put #1, 14369, String$(lngBytesRemainMR, Chr$(0))
                End If
            
                'put the MR into a variable
                Open sFile For Binary As #2
                    ReDim btMR(LOF(2) - 1) As Byte
                    Get #2, , btMR
                Close #2
                
                'save the MR into the IP.BIN
                Put #1, 14369, btMR
            Close #1
            
    End Select
    
    Call MsgBox("The MR logo was successfully added!", vbInformation, "Information")
    
    Exit Sub
    
ErrorHandler:
    Close
    MsgBox "AddMRLogo - modMR" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"
    
End Sub

'Remove MR logo
Public Sub RemoveMRLogo(ByVal sFile As String, src As enm_Source)

On Error GoTo ErrorHandler

    Dim strMRData       As String
    Dim blnNoMR         As Boolean
    Dim lngByteIP()     As Long
    Dim lngBytesRemainMR         As Long
    Dim i As Integer, j As Integer
    
    Select Case src
    
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            
            Select Case MsgBoxA("Do you want to remove the MR logo from the current IP.BIN or the entire CD image?", "Question", "", MB_ICONQUESTION + MB_YESNOCANCEL, , "Cancel", "Current", "All")
                
                '// CURRENT
                Case vbYes
                    Open sFile For Binary As #1
                        ReDim btMR(3) As Byte
                        Get #1, bytePosition + (((2048 + lngBytesOfECC) * 7) + 32), btMR()
                        strMRData = StrConv(btMR(), vbUnicode)
                    Close #1
                        
                    If Mid$(strMRData, 1, 2) <> "MR" Then
                        Call MsgBox("There is no MR logo in this IP.BIN.", vbExclamation, "Error")
                        Exit Sub
                    Else
                        If MsgBox("Are you sure you want to remove the MR logo?", vbYesNo Or vbQuestion, "Information") = vbNo Then
                            Exit Sub
                        End If
                    End If
                    
                    lngBytesRemainMR = CLng("&H" & Hex$(Asc(Mid$(strMRData, 4, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 3, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 3, 1))))
                    
                    Open sFile For Binary As #1
                        Put #1, bytePosition + (((2048 + lngBytesOfECC) * 7) + 32), String$(2016, Chr$(0))
                    
                        lngBytesRemainMR = lngBytesRemainMR - 2016
                        
                        'loop until all of MR is removed
                        Do Until lngBytesRemainMR = 0
                            Seek #1, Loc(1) + lngBytesOfECC + 1 'seek over ECC
                            
                            If lngBytesRemainMR >= 2048 Then
                                Put #1, , String$(2048, Chr$(0)) 'remove current sector
                                lngBytesRemainMR = lngBytesRemainMR - 2048
                            Else
                                Put #1, , String$(lngBytesRemainMR, Chr$(0)) 'remove remaining bytes
                                lngBytesRemainMR = lngBytesRemainMR - lngBytesRemainMR
                            End If
                        Loop
                    Close #1
                      
                '// ALL
                Case vbNo
                    blnNoMR = True
                
                    'make sure there's at least one MR to remove
                    For i = LBound(IPS_AT_BYTE, 2) To UBound(IPS_AT_BYTE, 2)
                        If IPS_AT_BYTE(0, i) = "IP.BIN" Then
                        
                            Open sFile For Binary As #1
                                ReDim btMR(1) As Byte
                                Get #1, IPS_AT_BYTE(1, i) + (((2048 + lngBytesOfECC) * 7) + 32), btMR()
                                strMRData = StrConv(btMR(), vbUnicode)
                            Close #1
                            
                            If strMRData = "MR" Then
                                blnNoMR = False
                                Exit For
                            End If
                            
                        End If
                    Next
                    
                    If blnNoMR = True Then
                        Call MsgBox("There is no MR logo in this CD image.", vbExclamation, "Error")
                        Exit Sub
                    Else
                        If MsgBox("Are you sure you want to remove all MR logos?", vbYesNo Or vbQuestion, "Information") = vbNo Then
                            Exit Sub
                        End If
                    End If
                    
                    'remove any current MRs
                    For i = LBound(IPS_AT_BYTE, 2) To UBound(IPS_AT_BYTE, 2)
                        If IPS_AT_BYTE(0, i) = "IP.BIN" Then
                        
                            Open sFile For Binary As #1
                                ReDim btMR(3) As Byte
                                Get #1, IPS_AT_BYTE(1, i) + (((2048 + lngBytesOfECC) * 7) + 32), btMR()
                                strMRData = StrConv(btMR(), vbUnicode)
                            Close #1
                            
                            If Mid$(strMRData, 1, 2) = "MR" Then
                                lngBytesRemainMR = CLng("&H" & Hex$(Asc(Mid$(strMRData, 4, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 3, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 3, 1))))
                                
                                Open sFile For Binary As #1
                                    Put #1, IPS_AT_BYTE(1, i) + (((2048 + lngBytesOfECC) * 7) + 32), String$(2016, Chr$(0))
                                
                                    lngBytesRemainMR = lngBytesRemainMR - 2016
                                    
                                    'loop until all of MR is removed
                                    Do Until lngBytesRemainMR = 0
                                        Seek #1, Loc(1) + lngBytesOfECC + 1 'seek over ECC
                                        
                                        If lngBytesRemainMR >= 2048 Then
                                            Put #1, , String$(2048, Chr$(0)) 'remove current sector
                                            lngBytesRemainMR = lngBytesRemainMR - 2048
                                        Else
                                            Put #1, , String$(lngBytesRemainMR, Chr$(0)) 'remove remaining bytes
                                            lngBytesRemainMR = lngBytesRemainMR - lngBytesRemainMR
                                        End If
                                    Loop
                                Close #1
                            End If
                            
                        End If
                    Next
                
                '// cancel
                Case vbCancel
                    Exit Sub
                
            End Select
        
        '//
        '// IP.BIN
        '//
        Case SOURCE_IP
            Open sFile For Binary As #1
                ReDim btMR(3) As Byte
                Get #1, 14369, btMR()
                strMRData = StrConv(btMR(), vbUnicode)
            Close #1
                
            If Mid$(strMRData, 1, 2) <> "MR" Then
                Call MsgBox("There is no MR logo in this IP.BIN.", vbExclamation, "Error")
                Exit Sub
            Else
                If MsgBox("Are you sure you want to remove the MR logo?", vbYesNo + vbQuestion, "Information") = vbNo Then
                    Exit Sub
                End If
            End If
                
            lngBytesRemainMR = CLng("&H" & Hex$(Asc(Mid$(strMRData, 4, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strMRData, 3, 1)))), "0") & Hex$(Asc(Mid$(strMRData, 3, 1))))
            
            Open sFile For Binary As #1
                Put #1, 14369, String$(lngBytesRemainMR, Chr$(0))
            Close #1
            
    End Select

    Call MsgBox("The MR logo was successfully removed!", vbInformation, "Information")
    
    Exit Sub
    
ErrorHandler:
    Close
    MsgBox "RemoveMRLogo - modMR" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Sub

'Extract MR logo
Public Sub ExtractMRLogo(sFile As String, src As enm_Source)
    
On Error GoTo ErrorHandler

    Dim strIPData       As String
    Dim strMRData       As String
    Dim lngMRfs         As Long
    Dim strSaveName     As String
    Dim i               As Integer

    Select Case src
    
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            Open sFile For Binary As #1
                ReDim btIP(2048 - 1) As Byte 'buffer (size of sector)
                Get #1, bytePosition, btIP() 'put IP.BIN chunk in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
                
                For i = 1 To 15
                    Seek #1, Loc(1) + lngBytesOfECC + 1 'seek over ECC
                    Get #1, , btIP() 'put next chunk in to buffer
                    strIPData = strIPData & StrConv(btIP(), vbUnicode)
                Next
            Close #1
            
        '//
        '// CD-ROM
        '//
        Case SOURCE_CDROM
            ReDim btIP(32768 - 1) As Byte 'buffer for IP.BIN
            Call ExtractSector(strDrvLetter, CDROM_LBA, 16, btIP) 'put IP.BIN in buffer
            strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
    
        '//
        '// IP.BIN
        '//
        Case SOURCE_IP
            Open sFile For Binary As #1
                ReDim btIP(LOF(1)) As Byte 'buffer for IP.BIN
                Get #1, , btIP() 'put IP.BIN in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
            Close #1
            
    End Select
            
    If Mid$(strIPData, 14369, 2) <> "MR" Then
        MsgBox "There is no MR logo in this IP.BIN.", vbExclamation, "Error"
        Exit Sub
    End If
    
    'put MR into variable
    lngMRfs = CLng("&H" & Hex$(Asc(Mid$(strIPData, 14372, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strIPData, 14371, 1)))), "0") & Hex$(Asc(Mid$(strIPData, 14371, 1))))
    strMRData = Mid$(strIPData, 14369, lngMRfs)

    'where to extract to
    strSaveName = ShowSave("MR image (*.mr)|*.mr|All files (*.*)|*.*", "iplogo.mr", "mr", OVERWRITEPROMPT, frmMain)
    If strSaveName = "" Then Exit Sub
    
    'save mr
    Open strSaveName For Output As #1
        Print #1, strMRData;
    Close #1

    Call MsgBox("The MR logo was successfully extracted!", vbInformation, "Information")

    Exit Sub

ErrorHandler:
    Close
    MsgBox "ExtractMRLogo - modMR" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Sub

Public Sub ExtractTMMRLogo(sFile As String, src As enm_Source)
    
On Error GoTo ErrorHandler

    Dim strIPData       As String
    Dim strMRData       As String
    Dim strSaveName     As String
    Dim i               As Integer

    Select Case src
    
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            Open sFile For Binary As #1
                ReDim btIP(2048 - 1) As Byte 'buffer (size of sector)
                Get #1, bytePosition, btIP() 'put IP.BIN chunk in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
                
                For i = 1 To 15
                    Seek #1, Loc(1) + lngBytesOfECC + 1 'seek over ECC
                    Get #1, , btIP() 'put next chunk in to buffer
                    strIPData = strIPData & StrConv(btIP(), vbUnicode)
                Next
            Close #1
            
        '//
        '// CD-ROM
        '//
        Case SOURCE_CDROM
            ReDim btIP(32768 - 1) As Byte 'buffer for IP.BIN
            Call ExtractSector(strDrvLetter, CDROM_LBA, 16, btIP) 'put IP.BIN in buffer
            strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
    
        '//
        '// IP.BIN
        '//
        Case SOURCE_IP
            Open sFile For Binary As #1
                ReDim btIP(LOF(1)) As Byte 'buffer for IP.BIN
                Get #1, , btIP() 'put IP.BIN in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
            Close #1
            
    End Select
    
    'put TM logo in variable
    strMRData = Mid$(strIPData, 8813, 299)
            
    'where to save
    strSaveName = ShowSave("MR image (*.mr)|*.mr|All files (*.*)|*.*", "tm.mr", "mr", OVERWRITEPROMPT, frmMain)
    If strSaveName = "" Then Exit Sub
    
    'save
    Open strSaveName For Output As #1
        Print #1, strMRData;
    Close #1

    Call MsgBox("The TM MR logo was successfully extracted!", vbInformation, "Information")

    Exit Sub

ErrorHandler:
    MsgBox "ExtractTMMRLogo - modMR" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Sub

Public Sub ExtractSegaMRLogo(sFile As String, src As enm_Source)
    
On Error GoTo ErrorHandler

    Dim strIPData       As String
    Dim strMRData       As String
    Dim strSaveName     As String
    Dim i               As Integer

    Select Case src
    
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            Open sFile For Binary As #1
                ReDim btIP(2048 - 1) As Byte 'buffer (size of sector)
                Get #1, bytePosition, btIP() 'put IP.BIN chunk in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
                
                For i = 1 To 15
                    Seek #1, Loc(1) + lngBytesOfECC + 1 'seek over ECC
                    Get #1, , btIP() 'put next chunk in to buffer
                    strIPData = strIPData & StrConv(btIP(), vbUnicode)
                Next
            Close #1
            
        '//
        '// CD-ROM
        '//
        Case SOURCE_CDROM
            ReDim btIP(32768 - 1) As Byte 'buffer for IP.BIN
            Call ExtractSector(strDrvLetter, CDROM_LBA, 16, btIP) 'put IP.BIN in buffer
            strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
    
        '//
        '// IP.BIN
        '//
        Case SOURCE_IP
            Open sFile For Binary As #1
                ReDim btIP(LOF(1)) As Byte 'buffer for IP.BIN
                Get #1, , btIP() 'put IP.BIN in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
            Close #1
            
    End Select
    
    'put SEGA logo in a variable
    strMRData = Mid$(strIPData, 9112, 4311)
    
    'where to save
    strSaveName = ShowSave("MR image (*.mr)|*.mr|All files (*.*)|*.*", "sega.mr", "mr", OVERWRITEPROMPT, frmMain)
    If strSaveName = "" Then Exit Sub
    
    'save
    Open strSaveName For Output As #1
        Print #1, strMRData;
    Close #1

    Call MsgBox("The Sega MR logo was successfully extracted!", vbInformation, "Information")

    Exit Sub

ErrorHandler:
    MsgBox "ExtractSegaMRLogo - modMR" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Sub

'View MR logo
Public Sub ViewMRLogo(sFile As String, src As enm_Source)
    
'On Error GoTo ErrorHandler

    Dim btCompMR()      As Byte
    Dim btUncompMR()    As Byte
    Dim strIPData       As String
    Dim strMRData       As String
    Dim strMRpallete    As String
    Dim lngMRfs         As Long
    Dim lngMRoffset     As Long
    Dim lngMRwidth      As Long
    Dim lngMRheight     As Long
    Dim lngMRcolors     As Long
    Dim Run             As String
    Dim i As Integer, j As Long, k As Integer
    Dim x As Integer, y As Integer
    Dim R As Byte, G As Byte, b As Byte

    Select Case src
    
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            Open sFile For Binary As #1
                ReDim btIP(2048 - 1) As Byte 'buffer (size of sector)
                Get #1, bytePosition, btIP() 'put IP.BIN chunk in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
                
                For i = 1 To 15
                    Seek #1, Loc(1) + lngBytesOfECC + 1 'seek over ECC
                    Get #1, , btIP() 'put next chunk in to buffer
                    strIPData = strIPData & StrConv(btIP(), vbUnicode)
                Next
            Close #1
            
        '//
        '// CD-ROM
        '//
        Case SOURCE_CDROM
            ReDim btIP(32768 - 1) As Byte 'buffer for IP.BIN
            Call ExtractSector(strDrvLetter, CDROM_LBA, 16, btIP) 'put IP.BIN in buffer
            strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
    
        '//
        '// IP.BIN
        '//
        Case SOURCE_IP
            Open sFile For Binary As #1
                ReDim btIP(LOF(1)) As Byte 'buffer for IP.BIN
                Get #1, , btIP() 'put IP.BIN in buffer
                strIPData = StrConv(btIP(), vbUnicode) 'convert to a readable format
            Close #1
            
    End Select
            
    If Mid$(strIPData, 14369, 2) <> "MR" Then
        MsgBox "There is no MR logo in this IP.BIN.", vbExclamation, "Error"
        Exit Sub
    End If
    
    lngMRfs = CLng("&H" & Hex$(Asc(Mid$(strIPData, 14372, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strIPData, 14371, 1)))), "0") & Hex$(Asc(Mid$(strIPData, 14371, 1))))
    lngMRoffset = CLng("&H" & Hex$(Asc(Mid$(strIPData, 14380, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strIPData, 14379, 1)))), "0") & Hex$(Asc(Mid$(strIPData, 14379, 1))))
    lngMRwidth = CLng("&H" & Hex$(Asc(Mid$(strIPData, 14384, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strIPData, 14383, 1)))), "0") & Hex$(Asc(Mid$(strIPData, 14383, 1))))
    lngMRheight = Asc(Mid$(strIPData, 14387, 1))
    lngMRcolors = CLng("&H" & Hex$(Asc(Mid$(strIPData, 14396, 1))) & String$(2 - Len(Hex$(Asc(Mid$(strIPData, 14395, 1)))), "0") & Hex$(Asc(Mid$(strIPData, 14395, 1))))
    strMRpallete = Mid$(strIPData, 14399, lngMRcolors * 4)
    
    'put each color (4 bytes) each in their own element
    For i = 0 To lngMRcolors - 1
        ReDim Preserve strPalette(i) 'redimension array, leaving previous elements
        strPalette(i) = Mid$(strMRpallete, i * 4 + 1, 4) 'put color i in element i
    Next
    
    'get compressed bitmap
    strMRData = Mid$(strIPData, 14369, lngMRfs)
    btCompMR = StrConv(Mid$(strMRData, lngMRoffset + 1), vbFromUnicode)

    frmViewMR.Show
    
    'initialize variables
    i = 0
    j = 0
    
    ' **  Uncompress Compressed MR Bitmaps  **
    ' Ported From Delphi Code Written By kRYPT
    '    And Modified By [big_fury]SiZiOUS
    
    'uncompressed bitmap buffer
    ReDim btUncompMR(lngMRwidth * lngMRheight - 1)
    
    Do
        If btCompMR(i) < &H80 Then
            btUncompMR(j) = btCompMR(i) 'the bytes lower than 128 are recopied just as they are in the bitmap
            j = j + 1
            If j > UBound(btUncompMR) Then Exit Do
        Else
            If (btCompMR(i) = &H82) And (btCompMR(i + 1) >= &H80) Then
                'the tag &H82 is followed Nb of points decoded in Run
                Run = btCompMR(i + 1) - &H80 + &H100
                
                For k = 1 To Run
                    btUncompMR(j) = btCompMR(i + 2) 'by retaining only the 1 byte for each point
                    j = j + 1
                    If j > UBound(btUncompMR) Then Exit Do
                Next
                
                i = i + 2
            ElseIf btCompMR(i) = &H81 Then
                'the tag &H81 is followed by a byte giving Nb of points directly
                Run = btCompMR(i + 1)
                
                For k = 1 To Run
                    btUncompMR(j) = btCompMR(i + 2) 'idem: 1 byte on 2
                    j = j + 1
                    If j > UBound(btUncompMR) Then Exit Do
                Next
                
                i = i + 2
            Else
                'if > &H82 => code for Nb of points decoded in run
                Run = btCompMR(i) - &H80
                
                For k = 1 To Run
                    btUncompMR(j) = btCompMR(i + 1) 'coded on only one byte
                    j = j + 1
                    If j > UBound(btUncompMR) Then Exit Do
                Next
                
                i = i + 1
            End If
        End If
        i = i + 1
    Loop Until i >= (lngMRfs - lngMRoffset - 1)
    
    frmViewMR.Picture1.Width = (lngMRwidth * Screen.TwipsPerPixelX)
    frmViewMR.Picture1.Height = (lngMRheight * Screen.TwipsPerPixelY)
    frmViewMR.lblOffset.Caption = lngMRoffset
    frmViewMR.lblResolution.Caption = lngMRwidth & "x" & lngMRheight
    frmViewMR.lblColors.Caption = lngMRcolors
    frmViewMR.lblSize.Caption = (lngMRoffset + UBound(btCompMR) + 1) & " bytes (compressed) " & vbCrLf & _
                                (lngMRoffset + UBound(btUncompMR) + 1) & " bytes (uncompressed)"
    
    'reinitialize i
    i = 0
    
    For y = 0 To lngMRheight - 1 'loop the y coordinates
        For x = 0 To lngMRwidth - 1 'loop the x coordinates
            'get RGB values from palette for current pixel
            If btUncompMR(i) > UBound(strPalette) Then
                'fix for Windows CE
                R = Asc(Mid$(strPalette(0), 3, 1))
                G = Asc(Mid$(strPalette(0), 2, 1))
                b = Asc(Mid$(strPalette(0), 1, 1))
            Else
                R = Asc(Mid$(strPalette(btUncompMR(i)), 3, 1))
                G = Asc(Mid$(strPalette(btUncompMR(i)), 2, 1))
                b = Asc(Mid$(strPalette(btUncompMR(i)), 1, 1))
            End If
            
            'draw the pixel
            SetPixel frmViewMR.Picture1.hdc, x, y, RGB(R, G, b)
            
            'next pixel data
            i = i + 1
        Next
    Next
    
    'rest the drawn pixels
    frmViewMR.Picture1.Picture = frmViewMR.Picture1.Image
    frmViewMR.Picture1.Refresh

    Exit Sub

ErrorHandler:
    Close
    MsgBox "ViewMRLogo - modMR" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"
    
End Sub

