VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FL_CDReader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'****************************************
'*** Flamed CD Reader class
'***
'*** for reading sectors/MCN/ISRC
'*** from CD-R/ROM/RWs
'****************************************

Public Enum FL_BufferSize
    BS_TOO_BIG = -1
    BS_INVALID_TRACK = 0
End Enum

Public Enum FL_SectorSize
    SS_RAW_AUDIO_MODE0 = 2352
    SS_MODE1 = 2048
    SS_MODE2FORM1 = 2048
    SS_MODE2FORM2 = 2328
    SS_MODE2PLAIN = 2336
    SS_RAW_SUBCHANNELS = 2448
End Enum

Public Enum FL_SUBCHANNELS
    RCD_SUBCH_PW_RAW = &H1                            ' Raw Channels P-W
    RCD_SUBCH_Q = &H2                                 ' only Q channel
    RCD_SUBCH_PW_CORRECTED = &H4                      ' Channels P-W corrected
End Enum

' read a bunch of sectors from a disk
Public Function ReadSectorsLBA(DriveID As String, _
                LBA As Long, _
                sectors As Integer, _
                buffer() As Byte) As Boolean

    ReadSectorsLBA = CDRomReadCD(DriveID, _
                                 LBA, _
                                 sectors, _
                                 VarPtr(buffer(0)), _
                                 UBound(buffer), _
                                 RCD_USRDATA, _
                                 0)

End Function
