VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FL_DriveInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'****************************************
'*** Flamed Drive information
'***
'*** reads information about a drive
'****************************************

Private strVendor           As String
Private strProduct          As String
Private strRevision         As String

Private intHostAdapter      As Integer
Private intTarget           As Integer

Public Property Get vendor() As String
    vendor = strVendor
End Property

Public Property Get product() As String
    product = strProduct
End Property

Public Property Get revision() As String
    revision = strRevision
End Property

Public Property Get HostAdapter() As Integer
    HostAdapter = intHostAdapter
End Property

Public Property Get Target() As Integer
    Target = intTarget
End Property

Public Function GetInfo(ByVal driveid As String) As Boolean

    On Error GoTo ErrorHandler

    'If Not CDRomTestUnitReady(DriveID) Then Exit Function

    Dim manager         As New FL_Manager
    Dim char            As String

    char = manager.DrvID2DrvChr(driveid)

    intHostAdapter = Asc(Left$(cd.HAIDFromDrvChr(char), 1))
    intTarget = Asc(Right$(cd.HAIDFromDrvChr(char), 1))

    strVendor = cd.CDROMGetName(driveid, &H1)
    strProduct = cd.CDROMGetName(driveid, &H2)
    strRevision = cd.CDROMGetName(driveid, &H4)

    GetInfo = True

ErrorHandler:

End Function
