VERSION 5.00
Begin VB.Form frmCDROM 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Open CD-ROM"
   ClientHeight    =   2940
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4830
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2940
   ScaleWidth      =   4830
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3480
      TabIndex        =   4
      Top             =   2400
      Width           =   1215
   End
   Begin VB.CommandButton cmdRefresh 
      Height          =   315
      Left            =   4320
      Picture         =   "frmCDROM.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   3
      ToolTipText     =   "Refresh"
      Top             =   120
      Width           =   375
   End
   Begin VB.ComboBox cboDrives 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   120
      Width           =   4095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   2160
      TabIndex        =   1
      Top             =   2400
      Width           =   1215
   End
   Begin VB.ListBox lstTracks 
      Height          =   1620
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   4575
   End
End
Attribute VB_Name = "frmCDROM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private scsi    As ISCSI

Private cManager   As New FL_Manager
Private cCInfo     As New FL_CDInfo
Private cDrvNfo    As New FL_DriveInfo
Private cTInfo     As New FL_TrackInfo
Private cSInfo     As New FL_SessionInfo

Private Sub Form_Load()

    Dim spti    As New clsSPTI
    
    ' prefers SPTI take
    Set scsi = spti
    If Not (scsi.Installed And scsi.Initialized) Then
        MsgBox "No functioning interface found!", vbExclamation
        Unload Me
        Exit Sub
    End If

    If Not cManager.Init() Then
        MsgBox "No interfaces found.", vbExclamation, "Error"
        Unload Me
        Exit Sub
    End If
    
    ShowDrives
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    cManager.Goodbye
    
End Sub

Private Sub cmdOK_Click()

    Dim btMetaInfo()    As Byte
    Dim strMetaInfo     As String
    
    If InStr(1, lstTracks.Text, "IP.BIN") > 0 Then
        frmMain.mnuFileSave.Enabled = False
        frmMain.imgShowCDImage.Visible = False
        frmMain.mnuOptionsAddMRLogo.Enabled = False
        frmMain.mnuOptionsExtractMRLogo.Enabled = True
        frmMain.mnuOptionsRemoveMRLogo.Enabled = False
        frmMain.mnuOptionsViewMRLogo.Enabled = True
        frmMain.mnuOptionsExtractSegaMRLogo.Enabled = True
        frmMain.mnuOptionsExtractTMMRLogo.Enabled = True
        frmMain.mnuOptionsExtractIP.Caption = "Extract IP.BIN"
        frmMain.mnuOptionsExtractIP.Enabled = True
        frmMain.cmdSave.Enabled = False
    Else
        frmMain.mnuFileSave.Enabled = False
        frmMain.imgShowCDImage.Visible = False
        frmMain.mnuOptionsAddMRLogo.Enabled = False
        frmMain.mnuOptionsExtractMRLogo.Enabled = False
        frmMain.mnuOptionsRemoveMRLogo.Enabled = False
        frmMain.mnuOptionsViewMRLogo.Enabled = False
        frmMain.mnuOptionsExtractSegaMRLogo.Enabled = False
        frmMain.mnuOptionsExtractTMMRLogo.Enabled = False
        frmMain.mnuOptionsExtractIP.Caption = "Extract IP0000.BIN"
        frmMain.mnuOptionsExtractIP.Enabled = True
        frmMain.cmdSave.Enabled = False
    End If
    
    strDrvLetter = Left(cboDrives.Text, 1) & ":\"
    
    CDROM_LBA = lstTracks.ItemData(lstTracks.ListIndex)
    
    Call ExtractSector(strDrvLetter, CDROM_LBA, 1, btMetaInfo)
    
    strMetaInfo = Left(StrConv(btMetaInfo, vbUnicode), 256)
    
    Call ReadIP(strDrvLetter, SOURCE_CDROM, strMetaInfo)
    
    Unload Me
    
End Sub

Private Sub cmdCancel_Click()

    Unload Me

End Sub

Private Sub cmdRefresh_Click()

    Call cboDrives_Click

End Sub

Private Sub cboDrives_Click()
    
    lstTracks.Clear
    
    strDrvLetter = Left(cboDrives.Text, 1)
    
    If cManager.IsCDVDDrive(strDrvLetter) Then
        Info
    End If
    
End Sub

Private Sub lstTracks_Click()

    If lstTracks.Text = "" Then cmdOK.Enabled = False Else cmdOK.Enabled = True
    
End Sub

Private Sub lstTracks_DblClick()

    Call cmdOK_Click
    
End Sub

Private Sub Info()

    Dim i As Integer, j As Integer
    Dim cdb(5)      As Byte
    Dim strDrvIDt   As String
    Dim indx        As Integer
    Dim sBuffer  As String
    

    cdb(0) = 0                  ' TEST UNIT READY OpCode
    

    ' select the drive assembly over Combobox cunning index
    strDrvIDt = scsi.DriveHandle(cboDrives.ListIndex + 1)
    
Retry:
    If IsDVD(strDrvIDt) = True Then
        If MsgBox("The current disc in drive " & strDrvIDt & ":\ is a DVD. Please insert a CD-ROM and click retry.", vbExclamation + vbRetryCancel, "Error") = vbRetry Then
            GoTo Retry
        End If
        Exit Sub
    End If

    ' check the status of the CD-ROM drive
    Select Case scsi.ExecCMD(strDrvIDt, cdb, 6, DIR_IN, 0, 0)
        Case STATUS_CHKCOND:
            ' Sense Code examine
            If scsi.LastSK = 2 And scsi.LastASC = &H3A Then
                If MsgBox("Please insert a CD-ROM into drive " & strDrvIDt & ":\ and click retry.", vbCritical + vbRetryCancel, "Error") = vbRetry Then
                    GoTo Retry
                End If
                Exit Sub
            Else
                If MsgBox("Please wait until drive " & strDrvIDt & ":\ is ready and try again.", vbExclamation + vbRetryCancel, "Warning") = vbRetry Then
                    GoTo Retry
                End If
                Exit Sub
            End If
    End Select
    
    If Not cCInfo.GetInfo(strDrvIDt) Then
        MsgBox "Couldn't read CD information", vbExclamation, "Error"
        Exit Sub
    End If

    ' loop sessions
    For i = 1 To cCInfo.Sessions

        If Not cSInfo.GetInfo(strDrvIDt, i) Then
            MsgBox "Couldn't read information about session " & i, vbExclamation, "Error"
            GoTo SkipSession
        End If

        ' loop tracks for the current session
        For j = cSInfo.FirstTrack To cSInfo.LastTrack
            
            If Not cTInfo.GetInfo(strDrvIDt, j) Then
                MsgBox "Couldn't read information about track " & j, vbExclamation, "Error"
                GoTo SkipTrack
            End If

            If cTInfo.mode = FL_TrackModes.MODE_AUDIO Then
                GoTo SkipTrack
            End If
            
            'list all IP and IP0000 found
            ReDim btBuffer(32768 - 1) As Byte
            
            Select Case ExtractSector(strDrvIDt, cTInfo.TrackStart.LBA, 16, btBuffer)
                    
                Case FORMAT_IP
                    sBuffer = StrConv(btBuffer, vbUnicode)
                    
                    If Mid$(sBuffer, 14369, 2) = "MR" Then
                        lstTracks.AddItem "IP.BIN with MR logo found in Track " & format(j, "00") & " (Session " & format(i, "00") & ")"
                    Else
                        lstTracks.AddItem "IP.BIN found in Track " & format(j, "00") & " (Session " & format(i, "00") & ")"
                    End If
                    
                    lstTracks.ItemData(indx) = cTInfo.TrackStart.LBA
                    indx = indx + 1
                    
                Case FORMAT_IP0000
                    lstTracks.AddItem "IP0000.BIN found in Track " & format(j, "00") & " (Session " & format(i, "00") & ")"
                    lstTracks.ItemData(indx) = cTInfo.TrackStart.LBA
                    indx = indx + 1
                    
            End Select
            
SkipTrack:
        Next j

SkipSession:
    Next i
    
    ' nothing was found
    If lstTracks.ListCount = 0 Then
        Call MsgBox("There was no IP.BIN\IP0000.BIN found on this CD-ROM.", vbExclamation, "Error")
        Exit Sub
    End If

End Sub

Public Sub ShowDrives()

    Dim strDrvs()   As String
    Dim strDrives() As String
    Dim strName     As String
    Dim i           As Integer

    strDrvs = cManager.GetCDVDROMs

    For i = LBound(strDrvs) To UBound(strDrvs) - 1

        cDrvNfo.GetInfo strDrvs(i)
        
        ReDim Preserve strDrives(i) As String
        strDrives(i) = strDrvs(i)

    Next i

    For i = LBound(strDrives) To UBound(strDrives)

        cDrvNfo.GetInfo strDrives(i)

        strName = strDrives(i) & ": "
        strName = strName & cDrvNfo.vendor & " "
        strName = strName & cDrvNfo.product & " "
        strName = strName & cDrvNfo.revision & " "
        strName = strName & "[" & cDrvNfo.HostAdapter & ":" & cDrvNfo.Target & "]"
       
        frmCDROM.cboDrives.AddItem strName
        
    Next i

    frmCDROM.cboDrives.ListIndex = 0

End Sub
